/********* music class ************

By Michael Garcia mgarcia
email gwald@start.com.au

********* music class ************/


#ifndef MUSIC_H
 
#define MUSIC_H
#include <libps.h>


class music_c{
public:
	
       music_c(         unsigned long *seq = NULL,
                        unsigned long  *vh = NULL,
                        unsigned long *vb = NULL,
                        short mvol = 127,
                        short svol  = 127,
                        char mode = 1, // SSPLAY_PLAY
                        char count =  0 // SSPLAY_INFINITY
                         );

	void play(); //  Performance mode. SSPLAY_PAUSES = switches to pause state | SSPLAY_PLAY = Performs immediately  | SSPLAY_INFINITY = is specified if there are an infinite number of performances.
	void stop();
	char init();
        void fadeOut(unsigned long  dur = 1000);
        void fadeIn(unsigned long  dur = 1000);
		void vol(unsigned long  vol = 55);


        unsigned long  *seqAdd_m; // SEQ data:Score data
        unsigned long  *vhAdd_m;  // VH data: Sampled data (attribute part)
        unsigned long  *vbAdd_m;  // VB data: Sampled data (waveform part)
		short mvol_m, // main volume
		svol_m; // seq volume


	char vabId_m, // vab id
		seqId_m; // seq id


	char mode_m, //  Performance mode. SSPLAY_PAUSES = switches to pause state | SSPLAY_PLAY = Performs immediately  | SSPLAY_INFINITY = is specified if there are an infinite number of performances.
		 count_m; //  Number of tune repetitions



};
#endif
